This Bugzilla instance is a read-only archive of historic NetBeans bug reports. To report a bug in NetBeans please follow the project's instructions for reporting issues.

Bug 242091

Summary: Usability: Stepping through JDK sources does not display local variables
Product: debugger Reporter: Jiri Kovalsky <jkovalsky>
Component: CodeAssignee: Martin Entlicher <mentlicher>
Status: VERIFIED FIXED    
Severity: normal Keywords: 8.0_HR_FIX, USABILITY
Priority: P2    
Version: 7.4   
Hardware: PC   
OS: Linux   
Issue Type: DEFECT Exception Reporter:

Description Jiri Kovalsky 2014-02-19 11:45:20 UTC
Product Version: NetBeans IDE 7.4 (Build 201310111528)
Java: 1.7.0_51; Java HotSpot(TM) Client VM 24.51-b03
Runtime: Java(TM) SE Runtime Environment 1.7.0_51-b13
System: Linux version 3.0.0-12-generic running on i386; UTF-8; cs_CZ (nb)
User directory: /home/cesilko/.netbeans/7.4
Cache directory: /home/cesilko/.cache/netbeans/7.4

Description:
============
When user steps through JDK sources it's not possible to see values of local variables, because the sources were not compiled with -g option. This is fine however the warning "Variable information not available, source compiled without -g option" is last entry in the "Variables" view instead of being first. User is confused and angry. It would be great if this message is listed as the first in the table. At least. Ideally, "<variable> is not a known variable in the current context." should be also changed in such situation to explain the reason.
Comment 1 Jiri Kovalsky 2014-02-19 12:45:09 UTC
Since this is a serious usability issue which should be fixed in 8.0 timeframe I am increasing priority accordingly.
Comment 2 Martin Entlicher 2014-02-19 16:38:55 UTC
Fixed in trunk by changeset:   272458:cd497a606726
http://hg.netbeans.org/core-main/rev/cd497a606726

With H. Peska (UI) we've agreed, that it's illogical to display the warning about "Variable information not available..." before some variables (method arguments).
To make it more noticeable, I've made it bold red, which should be sufficient IMHO. When the user is looking for some variables, they will scroll to the bottom and will see the warning.
It's a pity, that the warning text can not span across multiple columns, Outline view does not allow that.

I've also changed the tooltips, and the value text of missing variables in Watches. Now it says:
"Variable information is not available, source compiled without -g option. Value of <variable name> is not known."

Please verify soon so that it can be back-ported into 8.0.
Comment 3 Quality Engineering 2014-02-20 03:03:19 UTC
Integrated into 'main-silver', will be available in build *201402200001* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)

Changeset: http://hg.netbeans.org/main-silver/rev/cd497a606726
User: mentlicher@netbeans.org
Log: #242091: Make the "Variable information not available..." information text more visible by showing it as bold red. Also, when AbsentInformationException is encountered during evaluation, the error message says, that variable information is not available.
Comment 4 Jaroslav Havlin 2014-02-20 09:33:51 UTC
> Please verify soon so that it can be back-ported into 8.0.
The changes in code seem fine to me. Thank you.
Comment 5 Jiri Kovalsky 2014-02-20 10:35:34 UTC
Product Version: NetBeans IDE Dev (Build 201402200001)
Java: 1.8.0-ea; Java HotSpot(TM) 64-Bit Server VM 25.0-b63
Runtime: Java(TM) SE Runtime Environment 1.8.0-ea-b121
System: Linux version 3.0.0-12-generic running on amd64; UTF-8; cs_CZ (nb)
User directory: /home/cesilko/.netbeans/dev
Cache directory: /home/cesilko/.cache/netbeans/dev

Verified. Please proceed with integration into release80 branch. Thanks.
Comment 6 Martin Entlicher 2014-02-20 17:55:28 UTC
Thanks for the review and verification.
Transplanted into release80:
http://hg.netbeans.org/releases/rev/501719d6b25a
Comment 7 Quality Engineering 2014-02-21 01:29:47 UTC
Integrated into 'releases/release80', will be available in build *201402202300* or newer. Wait for official and publicly available build.

Changeset: http://hg.netbeans.org/releases/rev/501719d6b25a
User: mentlicher@netbeans.org
Log: #242091: Make the "Variable information not available..." information text more visible by showing it as bold red. Also, when AbsentInformationException is encountered during evaluation, the error message says, that variable information is not available.
(transplanted from cd497a606726f7e49caae9153e7408c60e9d8df3)
Comment 8 Jiri Kovalsky 2014-02-21 11:57:00 UTC
Product Version: NetBeans IDE 8.0 RC1 (Build 201402202300)
Java: 1.8.0-ea; Java HotSpot(TM) 64-Bit Server VM 25.0-b63
Runtime: Java(TM) SE Runtime Environment 1.8.0-ea-b121
System: Linux version 3.0.0-12-generic running on amd64; UTF-8; cs_CZ (nb)
User directory: /home/cesilko/.netbeans/8.0rc1
Cache directory: /home/cesilko/.cache/netbeans/8.0rc1

Verified in the NetBeans IDE 8.0 Release Candidate 1 build. Thanks for the quick fix!